﻿using System;
using System.Diagnostics;
using System.Net;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Pivot.Core;
using Telerik.Windows.Controls;

namespace RadPivotGrid_SL_TimeSpanAggregation
{
    public class CellTemplateSelector : DataTemplateSelector
    {
        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            var cellAggregate = item as CellAggregateValue;
            
            if (cellAggregate != null && cellAggregate.Description.ToString() == typeof(TimeSpanAggregate).ToString())
            {
                TimeSpan timeSpan = (TimeSpan)cellAggregate.Value;
                string valueToShow = this.TimeSpanToString(timeSpan);
                //Currently there is a problem with RadPivotGrid when in the CellTemplate there is only TextBlock, that's why we've added StackPanel below
                string dataTemplatePart1 = 
                @"<DataTemplate xmlns=""http://schemas.microsoft.com/client/2007"" >
                        <StackPanel VerticalAlignment=""Center"" HorizontalAlignment=""Right"" Margin=""4"">
                            <TextBlock Text=""";
                string dataTemplatePart2 = @"""/>
                        </StackPanel>
                  </DataTemplate>";
                Debug.WriteLine(dataTemplatePart1 + valueToShow + dataTemplatePart2);
                DataTemplate dataTemplate = (DataTemplate)XamlReader.Load(dataTemplatePart1 + valueToShow + dataTemplatePart2);
                return dataTemplate;
            }

            return base.SelectTemplate(item, container);
        }

        public string TimeSpanToString(TimeSpan timespan)
        {
            if (timespan.Days == 0) // sans afficher le nombre de jour
            {
                return timespan.ToString("hh\\:mm");
            }
            else if (timespan.Days == 1) // afficher jour avec internalisation
            {
                StringBuilder l_timespanFormated = new StringBuilder();
                l_timespanFormated.Append(string.Concat(timespan.Days.ToString(), " ", "Jour"));
                l_timespanFormated.Append(timespan.ToString("\\ hh\\:mm"));

                return l_timespanFormated.ToString();
            }
            else // afficher le nombre de jour avec internalisation
            {
                StringBuilder l_timespanFormated = new StringBuilder();
                if (timespan.Days < 0) return "Error"; //ce nombre ne peut être négatif
                l_timespanFormated.Append(string.Concat(timespan.Days.ToString(), " ", "Jours"));
                l_timespanFormated.Append(timespan.ToString("\\ hh\\:mm"));

                return l_timespanFormated.ToString();
            }
        }
    }
}
