﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Telerik.Pivot.Core.Aggregates;

namespace RadPivotGrid_SL_TimeSpanAggregation
{
    class TimeSpanStringFormatSelector : StringFormatSelector
    {
        public override string SelectStringFormat(Type dataType, Telerik.Pivot.Core.PropertyAggregateDescriptionBase aggregateDescription)
        {
            string format = base.SelectStringFormat(dataType, aggregateDescription);
            
            if (dataType == typeof(TimeSpan))
            {
                format = aggregateDescription.StringFormat ?? @"dd' jour 'hh' : 'mm' : 'ss\.ffff";
            }
            return format;
        }

        protected override void CloneCore(Telerik.Pivot.Core.Cloneable source)
        {
        }

        protected override Telerik.Pivot.Core.Cloneable CreateInstanceCore()
        {
            return new TimeSpanStringFormatSelector();
        }
    }
}
